public class Sedia
{
	/**
	* Campo privato che conta il numero di accessi eseguiti allo stato della classe.
	*/
	private static int globalAccessCount = 0;

	private int accessCount = 0;
	private boolean occupata = false;
	private String coloreCorrente = "bianco";
	private String[] palette;

	public Sedia(String[] paletteCustom)
	{
		palette = paletteCustom;
	}

	public Sedia()
	{
		//non funziona, la sintassi particolare ve la dico domani :-)
		// this(new String["a","b","c"]);// = {"rosso", "verde", "blu"});

		//la sintassi corretta e' questa
		this(new String[]{"rosso", "verde", "blu"});
	}

	/**
	* Metodo che testa lo stato libero/occupato dell'istanza. Ritorna true se l'istanza e' occupata.
	*/
	public boolean isOccupata()
	{
		return occupata;
	}

	public boolean occupa()
	{
		if(occupata)
		{
			return false;
		}
		accessCount++;
		globalAccessCount++;
		return (occupata = true);
	}

	public boolean libera()
	{
		if(!occupata)
		{
			return false;
		}
		accessCount++;
		globalAccessCount++;
		occupata = false;
		return true;
	}

	/**
	* Metodo per cambiare colore alla sedia. Il parametro formale rappresenta il
	* nuovo colore. Il valore di ritorno e' il colore precedente.
	*/
	public String colora(String nuovoColore)
	{
		String retval = coloreCorrente;
		coloreCorrente = nuovoColore;
		return retval;
	}

	public String colora(int nuovoColore)
	{
		/*
		String retval = coloreCorrente;
		coloreCorrente = palette[nuovoColore];
		return retval;
		*/
		return /*da qui*/colora(palette[nuovoColore]);/*a qui*///valuta a String
	}

	/**
	* Metodo per la lettura del colore corrente della sedia.
	*/
	public String getColore()
	{
		return coloreCorrente;
	}

	public int getCounter()
	{
		return accessCount;
	}

	public static int getGlobalCounter()
	{
		return globalAccessCount;
	}

	public static void main(String[] sarchiapone)
	{
		System.out.println("Questa volta entro da Sedia");
		GestisciSedie.main(sarchiapone);
	}
}
