package it.unipd.stat.se2.collections;

import java.util.*;
import java.io.*;

public class CaricaStudenti
{
	List<Studente> l;

	public static void main(String[] argv)
	{
		(new CaricaStudenti()).execute(argv);
	}

	public CaricaStudenti()
	{
		l = new ArrayList<Studente>();
	}

	public void execute(String[] argv)
	{
		if(carica(argv[0]))
		{
			visualizza();
		}
		else
		{
			System.out.println("Non riesco a caricare i dati");
		}
	}
	
	public boolean carica(String nomeFile)
	{
		File f = new File(nomeFile);
		if(!f.exists())
		{
			System.out.println("File <" + nomeFile + "> non esiste");
			return false;
		}

		if(!f.canRead())
		{
			System.out.println("File <" + nomeFile + "> non puo' essere letto");
			return false;
		}

		try
		{
			BufferedReader br = new BufferedReader(new FileReader(f));
			while(true)
			{
				Studente s = new Studente();
				if(s.popola(br) == true)
				{
					l.add(s);
				}
				else
				{
					break;
				}
			}
			try
			{
				br.close();
			}
			catch(IOException ioe2)
			{
				ioe2.printStackTrace();
			}
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
			return false;
		}
		return true;
	}

	public void visualizza()
	{
		Collections.sort(l, new ComparaCognomeNome());
		System.out.println(l);
	}
}
